import os, glob, shutil, subprocess, time
from sys import stdout

# ***************************************************************************
# create DC output directory
def create_outdir(path):
	# if path exists, delete all files in it
	if os.path.isdir(path) == True:
		files = glob.glob(path + '/*')
		for i in files:
			if os.path.isdir(i):
				files_1 = glob.glob(i + '/*')
				for j in files_1:
					os.remove(j)
				os.rmdir(i)
			else:
				os.remove(i)
	# if not, create one
	else:
		os.mkdir(path, 0777)

# ***************************************************************************


# ******************************************************************************
# run DC in given path (import tcl_file path in terms of dc_path) 
def run_dc(dc_path, tcl_file):
	os.chdir(dc_path)
	dc_cmd = 'dc_shell -f ' + tcl_file
	p = subprocess.Popen(dc_cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
	out = p.communicate()[0]

# ******************************************************************************


# ******************************************************************************
# read text file
def read_txt(rpt):
	content = open(rpt, 'r')
	return content.readlines()
	content.close()

# ******************************************************************************


# *******************************************************************************
# test program
def test():
	outdir = '../dc_syn'
	netlist = '../verilog/adder_syn.v'
	tcl = '../scripts/DC_1st_script.tcl'

	create_outdir(outdir)
	shutil.copy(netlist, outdir+'/syn_opt.v')
	run_dc(outdir, tcl)
	content = read_txt(outdir+'/test_area.rpt')
	print content

#test()

# *******************************************************************************
